/**
 * Copyright 2008 Bluestem Software LLC.  All Rights Reserved.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

package org.bluestemsoftware.open.eoa.example.order.manager.service.dao;

import java.util.HashMap;
import java.util.Map;

import org.bluestemsoftware.open.eoa.example.order.manager.service.vo.CustomerOrder;

public class CustomerOrderDAO implements DataAccessObject {

    private Map<String, CustomerOrder> customerOrders;
    
    private CustomerOrderDAO() {
        
        // TODO: replace map with a datasource injected using
        // spring's jee:jndi-lookup tag once ldap directory
        // server feature is implemented (which will bind all
        // connectors by default)
        
        customerOrders = new HashMap<String, CustomerOrder>();
        
    }
    
    public synchronized void insertCustomerOrder(CustomerOrder customerOrder) {
        
        // TODO: insert a customer order record into db where
        // order number is pk, status is a field and using
        // two tables that model the one to many relationship
        // between customer order and items, insert the
        // items
        
        customerOrders.put(customerOrder.getOrderNumber(), customerOrder);
        
    }
    
    public synchronized CustomerOrder selectCustomerOrder(String orderNumber) {
        return customerOrders.get(orderNumber);
    }
    
    public synchronized void updateCustomerOrder(CustomerOrder customerOrder) {
        
        // TODO: update customer order record in db, i.e.
        // set status, shipping price, etc ... where order
        // number is ... 
        
        customerOrders.put(customerOrder.getOrderNumber(), customerOrder);
        
    }
    
}
